//---     
#include "..\TestIndicatorConditions.mq5"
//---   
#include "Enums.mqh"
#include "InfoPanel.mqh"
#include "Errors.mqh"
#include "TradeFunctions.mqh"
#include "ToString.mqh"
#include "Auxiliary.mqh"
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void GetIndicatorHandle()
  {
//---    Moving Average
   if(Indicator==MA)
      indicator_handle=iMA(_Symbol,Period(),IndicatorPeriod,0,MODE_SMA,PRICE_CLOSE);
//---    CCI
   if(Indicator==CCI)
      indicator_handle=iCCI(_Symbol,Period(),IndicatorPeriod,PRICE_CLOSE);
//---    MultiRange_PCH
   if(Indicator==PCH)
      indicator_handle=iCustom(_Symbol,Period(),"MultiRange_PCH",IndicatorPeriod);
//---      
   if(indicator_handle==INVALID_HANDLE)
      Print("    !");
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
bool GetIndicatorsData()
  {
//---     
   if(indicator_handle!=INVALID_HANDLE)
     {
      //---   Moving Average  CCI
      if(Indicator==MA || Indicator==CCI)
        {
         //---     (... 3 2 1 0)
         ArraySetAsSeries(indicator_buffer1,true);
         //---   
         if(CopyBuffer(indicator_handle,0,0,AllowedNumberOfSegments,indicator_buffer1)<AllowedNumberOfSegments)
           {
            Print("    ("+
                  _Symbol+"; "+TimeframeToString(Period())+")   indicator_buffer1!  ("+
                  IntegerToString(GetLastError())+"): "+ErrorDescription(GetLastError()));
            return(false);
           }
        }
      //---   MultiRange_PCH
      if(Indicator==PCH)
        {
         //---     (... 3 2 1 0)
         ArraySetAsSeries(indicator_buffer1,true);
         ArraySetAsSeries(indicator_buffer2,true);
         //---   
         if(CopyBuffer(indicator_handle,0,0,AllowedNumberOfSegments,indicator_buffer1)<AllowedNumberOfSegments || 
            CopyBuffer(indicator_handle,1,0,AllowedNumberOfSegments,indicator_buffer2)<AllowedNumberOfSegments)
           {
            Print("    ("+
                  _Symbol+"; "+TimeframeToString(Period())+")   indicator_buffer1  indicator_buffer2!  ("+
                  IntegerToString(GetLastError())+"): "+ErrorDescription(GetLastError()));
            return(false);
           }
        }
      //---
      return(true);
     }
//---     ,     
   else
      GetIndicatorHandle();
//---
   return(false);
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
void GetBarsData()
  {
//---     (... 3 2 1 0)
   ArraySetAsSeries(close_price,true);
   ArraySetAsSeries(open_price,true);
   ArraySetAsSeries(high_price,true);
   ArraySetAsSeries(low_price,true);
//---    
//       ,  ,    
   if(CopyClose(_Symbol,Period(),0,AllowedNumberOfSegments,close_price)<AllowedNumberOfSegments)
     {
      Print("    ("
            +_Symbol+", "+TimeframeToString(Period())+")    Close! "
            " "+IntegerToString(GetLastError())+": "+ErrorDescription(GetLastError()));
     }
//---    
//       ,  ,    
   if(CopyOpen(_Symbol,Period(),0,AllowedNumberOfSegments,open_price)<AllowedNumberOfSegments)
     {
      Print("    ("
            +_Symbol+", "+TimeframeToString(Period())+")    Open! "
            " "+IntegerToString(GetLastError())+": "+ErrorDescription(GetLastError()));
     }
//---    
//       ,  ,    
   if(CopyHigh(_Symbol,Period(),0,AllowedNumberOfSegments,high_price)<AllowedNumberOfSegments)
     {
      Print("    ("
            +_Symbol+", "+TimeframeToString(Period())+")    High! "
            " "+IntegerToString(GetLastError())+": "+ErrorDescription(GetLastError()));
     }
//---    
//       ,  ,    
   if(CopyLow(_Symbol,Period(),0,AllowedNumberOfSegments,low_price)<AllowedNumberOfSegments)
     {
      Print("    ("
            +_Symbol+", "+TimeframeToString(Period())+")    Low! "
            " "+IntegerToString(GetLastError())+": "+ErrorDescription(GetLastError()));
     }
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
ENUM_ORDER_TYPE GetTradingSignal()
  {
//---   
   if(!pos.exists)
     {
      //---   
      if(GetSignal()==ORDER_TYPE_SELL)
         return(ORDER_TYPE_SELL);
      //---   
      if(GetSignal()==ORDER_TYPE_BUY)
         return(ORDER_TYPE_BUY);
     }
//---   
   if(pos.exists)
     {
      //---   
      GetPositionProperties(P_TYPE);
      //---    
      GetPositionProperties(P_PRICE_LAST_DEAL);
      //---       Moving Average  CCI
      if(Indicator==MA || Indicator==CCI)
        {
         //---   
         if(pos.type==POSITION_TYPE_BUY && 
            GetSignal()==ORDER_TYPE_SELL)
            return(ORDER_TYPE_SELL);
         //---
         if(pos.type==POSITION_TYPE_SELL && 
            GetSignal()==ORDER_TYPE_SELL && 
            close_price[1]<pos.last_deal_price-CorrectValueBySymbolDigits(VolumeIncreaseStep*_Point))
            return(ORDER_TYPE_SELL);
         //---   
         if(pos.type==POSITION_TYPE_SELL && 
            GetSignal()==ORDER_TYPE_BUY)
            return(ORDER_TYPE_BUY);
         //---
         if(pos.type==POSITION_TYPE_BUY && 
            GetSignal()==ORDER_TYPE_BUY && 
            close_price[1]>pos.last_deal_price+CorrectValueBySymbolDigits(VolumeIncreaseStep*_Point))
            return(ORDER_TYPE_BUY);
        }
      //---       MultiRange_PCH
      if(Indicator==PCH)
        {
         //---   
         if(pos.type==POSITION_TYPE_BUY && 
            close_price[1]<indicator_buffer2[1] && 
            open_price[1]>indicator_buffer2[1])
            return(ORDER_TYPE_SELL);
         //---
         if(pos.type==POSITION_TYPE_SELL && 
            close_price[1]<pos.last_deal_price-CorrectValueBySymbolDigits(VolumeIncreaseStep*_Point))
            return(ORDER_TYPE_SELL);
         //---   
         if(pos.type==POSITION_TYPE_SELL && 
            close_price[1]>indicator_buffer1[1] && 
            open_price[1]<indicator_buffer1[1])
            return(ORDER_TYPE_BUY);
         //---
         if(pos.type==POSITION_TYPE_BUY && 
            close_price[1]>pos.last_deal_price+CorrectValueBySymbolDigits(VolumeIncreaseStep*_Point))
            return(ORDER_TYPE_BUY);
        }
     }
//---  
   return(WRONG_VALUE);
  }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
ENUM_ORDER_TYPE GetSignal()
  {
//---     Moving Average  CCI
   if(Indicator==MA || Indicator==CCI)
     {
      //---   
      if(AllowedNumberOfSegments==3 && 
         indicator_buffer1[1]<indicator_buffer1[2])
         return(ORDER_TYPE_SELL);
      //---
      if(AllowedNumberOfSegments==4 && 
         indicator_buffer1[1]<indicator_buffer1[2] && 
         indicator_buffer1[2]<indicator_buffer1[3])
         return(ORDER_TYPE_SELL);
      //---
      if(AllowedNumberOfSegments==5 && 
         indicator_buffer1[1]<indicator_buffer1[2] && 
         indicator_buffer1[2]<indicator_buffer1[3] && 
         indicator_buffer1[3]<indicator_buffer1[4])
         return(ORDER_TYPE_SELL);
      //---
      if(AllowedNumberOfSegments==6 && 
         indicator_buffer1[1]<indicator_buffer1[2] && 
         indicator_buffer1[2]<indicator_buffer1[3] && 
         indicator_buffer1[3]<indicator_buffer1[4] && 
         indicator_buffer1[4]<indicator_buffer1[5])
         return(ORDER_TYPE_SELL);
      //---
      if(AllowedNumberOfSegments>=7 && 
         indicator_buffer1[1]<indicator_buffer1[2] && 
         indicator_buffer1[2]<indicator_buffer1[3] && 
         indicator_buffer1[3]<indicator_buffer1[4] && 
         indicator_buffer1[4]<indicator_buffer1[5] && 
         indicator_buffer1[5]<indicator_buffer1[6])
         return(ORDER_TYPE_SELL);

      //---   
      if(AllowedNumberOfSegments==3 && 
         indicator_buffer1[1]>indicator_buffer1[2])
         return(ORDER_TYPE_BUY);
      //---
      if(AllowedNumberOfSegments==4 && 
         indicator_buffer1[1]>indicator_buffer1[2] && 
         indicator_buffer1[2]>indicator_buffer1[3])
         return(ORDER_TYPE_BUY);
      //---
      if(AllowedNumberOfSegments==5 && 
         indicator_buffer1[1]>indicator_buffer1[2] && 
         indicator_buffer1[2]>indicator_buffer1[3] && 
         indicator_buffer1[3]>indicator_buffer1[4])
         return(ORDER_TYPE_BUY);
      //---
      if(AllowedNumberOfSegments==6 && 
         indicator_buffer1[1]>indicator_buffer1[2] && 
         indicator_buffer1[2]>indicator_buffer1[3] && 
         indicator_buffer1[3]>indicator_buffer1[4] && 
         indicator_buffer1[4]>indicator_buffer1[5])
         return(ORDER_TYPE_BUY);
      //---
      if(AllowedNumberOfSegments>=7 && 
         indicator_buffer1[1]>indicator_buffer1[2] && 
         indicator_buffer1[2]>indicator_buffer1[3] && 
         indicator_buffer1[3]>indicator_buffer1[4] && 
         indicator_buffer1[4]>indicator_buffer1[5] && 
         indicator_buffer1[5]>indicator_buffer1[6])
         return(ORDER_TYPE_BUY);
     }
//---       MultiRange_PCH
   if(Indicator==PCH)
     {
      //---   
      if(close_price[1]<indicator_buffer2[1] && 
         open_price[1]>indicator_buffer2[1])
         return(ORDER_TYPE_SELL);
      //---   
      if(close_price[1]>indicator_buffer1[1] && 
         open_price[1]<indicator_buffer1[1])
         return(ORDER_TYPE_BUY);
     }
//---  
   return(WRONG_VALUE);
  }
//+------------------------------------------------------------------+
