//+------------------------------------------------------------------+
//|                                      PositionPropertiesPanel.mq5 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//---
#define INFOPANEL_SIZE 19 //     -
#define EXPERT_NAME MQL5InfoString(MQL5_PROGRAM_NAME) //  
//---    
#include <Trade/Trade.mqh>
//---   
#include "Include\Enums.mqh"
#include "Include\InfoPanel.mqh"
#include "Include\Errors.mqh"
#include "Include\TradeSignals.mqh"
#include "Include\TradeFunctions.mqh"
#include "Include\ToString.mqh"
#include "Include\Auxiliary.mqh"
//---   
double               close_price[]; // Close (  )
double               open_price[];  // Open (  )
double               high_price[];  // High (  )
double               low_price[];   // Open (  )
//---    
double indicator_buffer1[];
double indicator_buffer2[];
//---   
sinput   long              MagicNumber=777;        //  
sinput   int               Deviation=10;           // 
input    ENUM_INDICATORS   Indicator=MA;           // 
input    int               IndicatorPeriod=5;      //  
input    int               IndicatorSegments=2;    // -   
input    double            Lot=0.1;                // 
input    double            VolumeIncrease=0.1;     //   
input    double            VolumeIncreaseStep=10;  //    
input    double            StopLoss=50;            //  
input    double            TakeProfit=100;         //  
input    double            TrailingStop=10;        //  
input    bool              Reverse=true;           //  
sinput   bool              ShowInfoPanel=true;     //   
//---      NumberOfBars
int                  AllowedNumberOfSegments=0;
//---  
int                  indicator_handle=INVALID_HANDLE;
//---  
CTrade               trade;
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
void CorrectInputParameters()
  {
//---        
   if(AllowedNumberOfSegments<=0)
     {
      if(IndicatorSegments<=1)
         AllowedNumberOfSegments=3;                     //     
      if(IndicatorSegments>=5)
         AllowedNumberOfSegments=5;                     //    7
      else
         AllowedNumberOfSegments=IndicatorSegments+1;   //     
     }
  }
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   
   CorrectInputParameters();
//---   
   GetIndicatorHandle();
//---   
   CheckNewBar();
//---  
   GetPositionProperties(P_ALL);
//---   
   SetInfoPanel();
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---     
   Print(GetDeinitReasonText(reason));
//---    
   if(reason==REASON_REMOVE)
     {
      //---     ,     
      DeleteInfoPanel();
      //---   
      IndicatorRelease(indicator_handle);
     }
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---    , 
   if(!CheckNewBar())
     {
      if(IsVisualMode() || IsRealtime())
        {
         //---       
         GetPositionProperties(P_ALL);
         //--- /  
         SetInfoPanel();
        }
      return;
     }

//---    
   else
     {
      //---    
      if(CheckTradingPermission()==0)
        {
         if(!GetIndicatorsData())
            return;
         GetBarsData();          //   
         TradingBlock();         //    
         ModifyTrailingStop();   //   Trailing Stop
        }
     }
//---  
   GetPositionProperties(P_ALL);
//---   
   SetInfoPanel();
  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OnTrade()
  {
//---   
   GetPositionProperties(P_ALL);
//---   
   SetInfoPanel();
  }
//+------------------------------------------------------------------+
